/**
 * PETALS: PETALS Services Platform Copyright (C) 2005 EBM WebSourcing
 * 
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or any later version.
 * 
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA.
 * 
 * Initial developer(s): EBM WebSourcing
 * --------------------------------------------------------------------------
 * $Id$
 * --------------------------------------------------------------------------
 */
package org.ow2.petals.ant.task;

import java.net.URL;

import org.ow2.petals.ant.AbstractInstallerAntTask;

/**
 * Ant task : jbi-deploy-service-assembly. This task deploys a service assembly
 * into the JBI environment.
 * 
 * @author ddesjardins chamerling - eBMWebsourcing
 */
public class DeployServiceAssemblyTask extends AbstractInstallerAntTask {

    /**
     * Creates a new instance of {@link DeployServiceAssemblyTask}
     * 
     */
    public DeployServiceAssemblyTask() {
        super();
    }

    /*
     * (non-Javadoc)
     * 
     * @see org.ow2.petals.ant.AbstractJBIAntTask#doTask()
     */
    @Override
    public void doTask() throws Exception {
        URL fileURL = validateFileParameter();

        String serviceAssemblyReport = this.getJMXClient().getDeploymentServiceClient().deploy(
                fileURL);

        // TODO: define a project to handle the XML report with Java binding
        // objects.
        if (serviceAssemblyReport.indexOf("Successfully") > -1) {
            // Extract the service assembly name
            String saName = serviceAssemblyReport.substring(serviceAssemblyReport
                    .indexOf("<loc-param>") + 11, serviceAssemblyReport.indexOf("</loc-param>"));
            log("Service assembly '" + saName + "' deployed");
        } else {
            log("Failed to deploy the Service Assembly located at '" + file + "' :\n"
                    + serviceAssemblyReport);

        }

    }
}
